package it.openutils.spring.validation.hibernate;

import org.hibernate.validator.ClassValidator;
import org.hibernate.validator.InvalidValue;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;


/**
 * @author fgiust
 * @version $Id: AnnotationValidator.java 146 2007-01-04 15:46:29Z fgiust $
 */
public class AnnotationValidator implements Validator
{

    /**
     * @see org.springframework.validation.Validator#supports(java.lang.Class)
     */
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz)
    {
        return true;
    }

    /**
     * {@inheritDoc}
     */
    @SuppressWarnings("unchecked")
    public void validate(Object obj, Errors errors)
    {
        ClassValidator classValidator = new ClassValidator(obj.getClass());
        InvalidValue[] validationMessages = classValidator.getInvalidValues(obj);
        for (InvalidValue value : validationMessages)
        {
            String propertyName = value.getPropertyName();

            String message = value.getMessage();

            errors.rejectValue(propertyName, null, message);
        }
    }
}
